/************************************************************
JavaScript Encapsulation Library.

Copyright (C) 2002, Alben Software, Inc.
All rights reserved.

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA  02111-1307, USA.

Alben Software, Inc.
Benny Pollak, President.
20 E 9th Street.
NY, NY 10003
benny@alben.com
*********************************************************************/
#ifndef __inetjs_h_
#define __inetjs_h_
#include "jsapi.h"
#include "jsobj.h"

class JS {
public:
	JS();
	~JS();
	int init();
	int Call(const char *func_name, uintN argc, jsval *argv, jsval *prval);
	int InstallScript(const char *script);
	int LookupProperty(char *name, jsval &xv);
	void SetStringVariable(const char *name, const char *val);
	char *GetStringVariable(char *name);
	void  toJSVal(long var, jsval &ret);
	void  toJSVal(long *vars, int count, jsval &ret);
	void  toJSVal(short *vars, int count, jsval &ret);
	void  toJSVal(unsigned short var, jsval &ret);
	void  toJSVal(short var, jsval &ret);
	void  toJSVal(float var, jsval &ret);
	void  toJSVal(double var, jsval &ret);
	void  toJSVal(float *vars, int count, jsval &ret);
	void  toJSVal(double *vars, int count, jsval &ret);
	void  toJSVal(unsigned short *var, jsval &ret);
	void  toJSVal(unsigned short *vars[], int count, jsval &ret);
	void  toJSBoolVal(short var, jsval &ret);
	void  newJSArray(int count, jsval &ret);
	void  addToJSArray(jsval &array, int index, jsval &item);
	void  toJSValArray(long *vars, int count, jsval &ret);

	int isJSBoolVal(const jsval &var);
	int isJSIntVal(const jsval &var);
	int isJSDoubleVal(const jsval &var);
	int isJSStringVal(const jsval &var);

	short getJSBoolVal(const jsval &var);
	long getJSIntVal(const jsval &var);
	double getJSDoubleVal(const jsval &var);
	char *getJSStringVal(const jsval &var);
	char *getError();
private:
	JSContext *cx_;
	JSObject  *glob_;
	JSVersion version_;
	JSRuntime *rt_;
	JSObject  *it_;
	JSBool builtins_;
	int initialized_;
	//
	// arguments end with NULL
	// maximum of 50 args
	int ExtendJS();
	void tester();
	static void MyErrorReporter(JSContext *cx, const char *message,
                                    JSErrorReport *report);
	static char *err_;
};

#endif
