/************************************************************
JavaScript Encapsulation Library.

Copyright (C) 2002, Alben Software, Inc.
All rights reserved.

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA  02111-1307, USA.

Alben Software, Inc.
Benny Pollak, President.
20 E 9th Street.
NY, NY 10003
benny@alben.com
*********************************************************************/
// JSHandler.h : Declaration of the CJSHandler

#ifndef __JSHANDLER_H_
#define __JSHANDLER_H_

#include "resource.h"       // main symbols
#include "jsapi.h"
#include "js.h"
#include "WError.h"

/////////////////////////////////////////////////////////////////////////////
// CJSHandler
class ATL_NO_VTABLE CJSHandler : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CJSHandler, &CLSID_JSHandler>,
	public ISupportErrorInfo,
	public IConnectionPointContainerImpl<CJSHandler>,
	public IDispatchImpl<IJSHandler, &IID_IJSHandler, &LIBID_JSSCRIPTLib>
{
public:
	STDMETHOD(InstallScript)(/*[in]*/ BSTR Script);
	STDMETHOD(Call0)(/*[in]*/ BSTR Func, /*[retval][out]*/ VARIANT *Ret);
	STDMETHOD(Call1)(/*[in]*/ BSTR Func, /*[in]*/ VARIANT  Arg1, /*[out][retval]*/ VARIANT *Ret);
	STDMETHOD(Call2)(/*[in]*/ BSTR Func, /*[in]*/ VARIANT  Arg1, /*[in]*/ VARIANT Arg2, /*[out][retval]*/ VARIANT *Ret);
	CJSHandler();
	~CJSHandler();
	HRESULT FinalConstruct();
	void FinalRelease();

DECLARE_REGISTRY_RESOURCEID(IDR_JSHANDLER)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CJSHandler)
	COM_INTERFACE_ENTRY(IJSHandler)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(ISupportErrorInfo)
	COM_INTERFACE_ENTRY(IConnectionPointContainer)
END_COM_MAP()
BEGIN_CONNECTION_POINT_MAP(CJSHandler)
END_CONNECTION_POINT_MAP()


// ISupportsErrorInfo
	STDMETHOD(InterfaceSupportsErrorInfo)(REFIID riid);

// IJSHandler
private:
	int fromJSVal(const jsval &var, VARIANT &ret);
	int toJSVal(const VARIANT &var, jsval &ret);
	HRESULT Call(BSTR Func, VARIANT *Ret, VARIANT *Arg, ...);

	JS js_;
	WError							wError_;
};

#endif //__JSHANDLER_H_
