/************************************************************
JavaScript Encapsulation Library.

Copyright (C) 2002, Alben Software, Inc.
All rights reserved.

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the
Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA  02111-1307, USA.

Alben Software, Inc.
Benny Pollak, President.
20 E 9th Street.
NY, NY 10003
benny@alben.com
*********************************************************************/
#include "stdafx.h"
#include "WError.h"
#include <oleauto.h>


WError::WError()
{
	CreateEInfo();
}

WError::~WError()
{
	if (pCreateErrorInfo_){
		pCreateErrorInfo_->Release();
	}
}

int WError::CreateEInfo()
{

	HRESULT hr = ::CreateErrorInfo(&pCreateErrorInfo_);
	if (FAILED(hr)){			
		pCreateErrorInfo_ = 0;
		return 0;
	}

	return 1;
}

int WError::SetError(const char* Description)
{
	if (!pCreateErrorInfo_ && !(CreateEInfo())){
		return 0;
	}

	USES_CONVERSION;
	pCreateErrorInfo_->SetDescription(A2BSTR(Description));
	IErrorInfo* pErrorInfo = 0;
	HRESULT hr =  pCreateErrorInfo_->QueryInterface(IID_IErrorInfo, (void**)&pErrorInfo);
	if SUCCEEDED(hr){
		::SetErrorInfo(0, pErrorInfo);
		pErrorInfo->Release();
		return 1;
	}

	return 0;
}
